//Open GL - Generate Gray Codes... 
//
//
//
//gcc -o Hello_World Hello_world.c -lX11 -lMesaGL -lMesaGLU -lMesatk -lm
//
#include <stdio.h> // for printf call
#include <stdlib.h> // for exit() call.
#include <strings.h>
#include <string.h>
#include <unistd.h>
#include <GL/glut.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <sys/types.h>
#include <assert.h>
#include <limits.h>   // for MAX_INT
#define BAUDRATE B19200
#define MODEMDEVICE "/dev/ttyUSB0"
#define _POSIX_SOURCE 1 /* POSIX compliant source */

// Holds handle to open serial port, and old terinal settings...
int fd;
struct termios oldtio;


int framesSinceLastReport;	// number of frames since the last report.
int lastX,lastY;		// Positions of the last report.

int bit = 0;
int repeatCount = 1; 


int timeOfLastRedraw = 0;


// The "repeatInverse" flag is used to indicate if we should be repeating
// the inverse of each bit immidately after sending it.
//  The repeatInverseCount = 1 means that we should be sending the inverted bit.
//int repeatInverse = 0;
//int repeatInverseCount = 0;

//FPS variables...
int fpsFlag = 1; // no FPS by default.
int frame=0,time,timebase=0; char fpsString[40];// FPS counter...
float fps; char *c;
int font=(int)GLUT_BITMAP_8_BY_13;

enum menuCodes {
QUIT};

void init(void); // function header for Init.
int getBitSEC_ECC(unsigned short databits, int bitPosition);




void InitSerialPort()
{
      int res;
      struct termios newtio;
      fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY );
      if (fd <0) {perror(MODEMDEVICE); exit(-1); }

      tcgetattr(fd,&oldtio); /* save current port settings */
      bzero(&newtio, sizeof(newtio));
      newtio.c_cflag = BAUDRATE |  CS8 | CLOCAL | CREAD;
      newtio.c_iflag = IGNPAR;
      newtio.c_oflag = 0;

 /* set input mode (non-canonical, no echo,...) */
										        newtio.c_lflag = 0;
       	newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
        newtio.c_cc[VMIN]     = 0;   /* blocking read until 5 chars received */
        tcflush(fd, TCIFLUSH);
        tcsetattr(fd,TCSANOW,&newtio);

}

int GetPacket(char* outputArray,int maxBytes)
{
  int res;
  static int bufpointer = 0;
  static char buf[255];
  char inChar;

	 assert(maxBytes < 255);

	 res = 1;
         while (res ==1)
     	 {
	   res = read(fd,&inChar,1);   /* try to read a char... */
	    if (res ==1)
            {
	     buf[bufpointer] = inChar;
	     if (buf[bufpointer] == '\n')
	      {
	         buf[bufpointer+1] = 0; // so we can strncpy
		 bufpointer = 0;
	         // Copy bufpointer to outputArray and return the
	         // length of the buffer.
	         strncpy(outputArray,buf,maxBytes);
	         return(strlen(buf));

                }
	     // check to see if our input is too long...
	    if (bufpointer > maxBytes)
	    {
	       bufpointer = -1;
	    }
	    bufpointer++;
       } // end if res == 1
      } // end while res == 1

   return(0);
}






void CloseSerialPort()
{
      tcsetattr(fd,TCSANOW,&oldtio); // restore old settings...
      close(fd);
}

void exit_cleanup()
{
	 
 CloseSerialPort();
 printf("Exiting cleanly...\n");
 exit(0);

}



void processMenuEvents(int option) {

  switch (option) {
	  case QUIT:
		  exit_cleanup();
	  default:
		  break;
  } // end switch.

}

void createGLUTMenus(){
	int menu;

	//create the meu and
	//tell glut that "processMenuEvents" will
	//handle the events
	menu = glutCreateMenu(processMenuEvents);
	glutAddMenuEntry("Quit",QUIT);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
	
}


static GLfloat spin  = 0.0;

int getBitSEC_ECC(unsigned short databits, int bitPosition)
{
	        // Load the databits into an array, one bit per element.
		  unsigned char d[16];
		  unsigned char c[21];
		  unsigned short int temp;

		   unsigned short int mask = 0x0001;
		    int i,j;
		     for(i = 0; i < 16; i++)
		      {
	               temp = 0x00;	
	               temp = databits & mask; // Grab one bit.
	               mask <<= 1; // advance to the next bit in the mask.
		    // Shift the data point back to the first bit position.
		             for(j = i; j>0; j--)
		                {
		                 temp >>= 1;
		                 }
			     d[i] = temp ;
		     }


	 // Move the data bits into the appropriate codeword positions
     c[2] = d[0];
     c[4] = d[1]; c[5]=d[2]; c[6] = d[3];
     c[8] = d[4]; c[9]=d[5]; c[10]=d[6]; c[11]=d[7]; c[12]=d[8]; c[13] = d[9];
     c[14] = d[10];
     c[16] = d[11]; c[17]=d[12]; c[18]=d[13]; c[19]=d[14]; c[20]=d[15];

     // Calculate the check bits.
     
     c[0] = c[2] ^ c[4] ^ c[6] ^ c[8] ^ c[10] ^ c[12] ^ c[14] ^ c[16] ^ c[18] ^ c[20];
     c[1] = c[2] ^ c[5] ^ c[6] ^ c[9] ^ c[10] ^ c[13] ^ c[14] ^ c[17] ^ c[18];
     c[3] = c[4] ^ c[5] ^ c[6] ^ c[11]^ c[12] ^ c[13] ^ c[14] ^ c[19] ^ c[20];
     c[7] = c[8] ^ c[9] ^ c[10] ^c[11] ^ c[12] ^ c[13] ^ c[14];
     c[15] = c[16] ^ c[17] ^ c[18] ^ c[19] ^ c[20];

     // return the appropriate bit...
     for(i = 0; i < 21; i++)
     {
	     if (i == bitPosition)
		     return(c[i]);
     }
     return(0); //should never be hit...
}

 

int getBit(int x, int y, int frame)
{

	 int internalBit = 0;
	 int positionNum = 0;
	 int n,v,dig,set,k;
	 unsigned short int temp;

		 // This one uses 21 bits to transfer 16 bits of data.
		 positionNum = x * 32 + y;
		 // We can use the upper six bits for whatever we want...
		 temp = (unsigned short int)positionNum;
		 temp |=0xA800;

		 //if (x == 0 && y == 0)
		//	 printf("Position is: %d\n",temp);

		return (getBitSEC_ECC(temp,frame));


 // If we ever get a filled screen, it's because this
 // return was executed!
  return(0);
}

void display(void)
{
 int i,j;

 //printf("Bit: %d",bit);
 //printf("  Sample Pixel (20,20) : %d\n", getBit(20,20,bit));

  // clear all pixels.
  glClear(GL_COLOR_BUFFER_BIT);

  // if we haven't gotten a report for a while, draw the tracking pattern.
  if (framesSinceLastReport > 100)
  {
  // Draw 32x32 rectangles...
  for( i=0; i < 32; i++)
     for( j = 0; j < 32; j++)
     {
	     int temp = getBit(i,j,bit);

       if (temp == 1)
       {
	               glColor3f(1.0, 1.0, 1.0);
       }
       else
	       glColor3f(0.0, 0.0, 0.0);

       glRectf( (i-16)*2 , 2*(j-16),((i-16)*2)+2,((j-16)*2)+2);

              // some computers don't sync redraws with vsync... (specifically mine)
	      // make sure we go no faster than 60hz.
	          while(glutGet(GLUT_ELAPSED_TIME) < timeOfLastRedraw + 16);
	      
     }
  } else  // Show where we found the sensor!
  {
    glColor3f(1.0,0.0,0.0);
    glRectf( (lastX-16)*2, 2*(lastY-16), ((lastX-16)*2)+2, ((lastY-16)*2)+2);
  }

  //glFlush();
  //glFinish();
   timeOfLastRedraw = glutGet(GLUT_ELAPSED_TIME);
  
  glutSwapBuffers();
}

// Checks to see where the sensor says it is....
// PIC sends the following two byte payload:
//  ;; Save the data into our bytes to send. (NOTE! We only save the 10 data bits.
//   ;; We also add a 4 bit (0-15) number representing which sensor we got the value off
//     ;; of. (Currently, we only have one sensor, number zero...)^M
//      ;; We also add 2 bits indicating what type of tracking pattern it was (01 - 10
//      bit track. 00-3 bit track)^M
//        ;; 10 3210 9876543210^M
//        ;; MM-SSSS-DDDDDDDDDD^M
//        ;; | High    | Low   |^M
//
void locate_sensor(void)
{
	// Every frame that we haven't heard from the sensor
	// we increment this...
	if (framesSinceLastReport == INT_MAX)
		framesSinceLastReport= INT_MAX -1;
	framesSinceLastReport++;

       char buffer[10];
       int res= GetPacket(buffer,10);
       int pt;

       if (res > 0)
       {
	if (strncmp(buffer,"Jay",3) == 0)
	{
		printf("Radio Receiver Initalized...\n");
	}
	else if (buffer[0] == 's') // Serial number for this pic is 0x73=s
	{
		// Buffer[0] - pic Serial number 
		// buffer[1] - function bits (not used currently)
		// buffer[2] - High data word
		// buffer[3] - low data word

	   unsigned char patternType = buffer[2];
	   patternType  >>= 6;  // Shift six bits away, leaving top two.
	   patternType &= 0x03; // Wipe out all but bottom two bits.
	   printf("Pattern type: %d  - ",(unsigned int) patternType);
	   pt = (unsigned int) patternType;

	   unsigned char sensorNumber = buffer[2];
	   sensorNumber >>=2; // shift two bits away, leave top six.
	   sensorNumber &= 0x0F; // we only want the bottom 4
	   printf("Sensor #: %d ",(unsigned int) sensorNumber);


	   // Decode the 10 bit number:
	   unsigned short int position = (unsigned short int) buffer[2]; 
	   // Wipe out all but the last two..
	   position &= 0x03;
	   // combine the 16 bits... 
	   // // First, move the high bits up...
	   position <<= 8;

	   unsigned short int temp;
	   temp = (unsigned short int) buffer[3];
	   temp &= 0x00FF;
           position &= 0xFF00;
	   position |= temp;

	   printf("Position decoded is: %d  - ",position);	   

	   lastX = position / 32;
	   lastY = position % 32;

	   // Only mark position types of 1.
	   if (pt == 1)
	     framesSinceLastReport = 0;

	   printf("(X:%d,Y:%d)\n",lastX, lastY);	
	   


	}


       }




}

void generate_code(void)
{

	locate_sensor();
	
	//FPS counter code:
	//
	frame++;
	time=glutGet(GLUT_ELAPSED_TIME);
			
	if (time - timebase > 1000) {
		fps = frame*1000.0/(time-timebase);
		printf("FPS:%4.2f\n", fps);
		timebase = time;		
		frame = 0;
	}

	// Increment the bit.
	bit++;

 if (repeatCount == 0)
 {
     glutIdleFunc(0);
     bit=0;
 }

 //determine how many bits to do and when to reset for SEC_ECC code...
 
	   if (bit > 20)
	   {
		   bit = 0;
		   repeatCount--;
	   }


glutPostRedisplay();

}

void reshape(int w, int h)
{
	glViewport(0,0,(GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-32.0,32.0,-32.0,32.0, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

//Keyboard handler
void keyboard(int key, int x, int y) {
	switch(key){
	case GLUT_KEY_F1:
		glutGameModeString("640x480");
		// This test always fails.. but the
		// code below seems to work for me :>
		//if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) {
			glutEnterGameMode();
			init();
	//	}else
	//		printf("GLUT- Full screen mode not possible");

		break;
	case GLUT_KEY_F2:
		glutFullScreen();
		break;
	case GLUT_KEY_F3:
		glutReshapeWindow(250,250);
		glutPositionWindow(100,100);
		break;
	case GLUT_KEY_F6:
		glutIdleFunc(0);
		repeatCount = 0;
		bit = 0;
		glutLeaveGameMode();
		break;
	} // end switch.

}

void mouse(int button, int state, int x, int y)
{
  switch(button) {
	  // Left button, run once...
	  case GLUT_LEFT_BUTTON:
		  if (state == GLUT_DOWN) {
			  bit = 0; // start at 0 bit.
			  repeatCount = 2; // repeat twice.
			  glutIdleFunc(generate_code);
		  }
		  break;
	  case GLUT_MIDDLE_BUTTON:
		  if (state == GLUT_DOWN) {
			  bit = 0; repeatCount = 32000;
			  glutIdleFunc(generate_code);
		  }
		  break;
	  default:
		  break;
  }
}

void init(void)
{
  glClearColor(0.0,0.0,0.0,0.0);
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutSpecialFunc(keyboard);

}

int main(int argc, char** argv)
{

  framesSinceLastReport = 400; // larger than the threshold to show red square!
  InitSerialPort();

  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGBA|GLUT_DOUBLE);
  glutInitWindowSize(250,250);
  glutInitWindowPosition(100,100);
  glutCreateWindow(argv[0]);
  init();
  createGLUTMenus();
  glutMainLoop();
  exit_cleanup();
  return 0;
}

