   #include <sys/types.h>
      #include <sys/stat.h>
      #include <fcntl.h>
      #include <termios.h>
      #include <stdio.h>
      #include <assert.h>
        
      #define BAUDRATE B19200
      #define MODEMDEVICE "/dev/ttyUSB0"
      #define _POSIX_SOURCE 1 /* POSIX compliant source */
        
     
      int fd;
      struct termios oldtio;


void InitSerialPort()
{
	int res;
	struct termios newtio;
        fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY );
	if (fd <0) {perror(MODEMDEVICE); exit(-1); }

        tcgetattr(fd,&oldtio); /* save current port settings */
        bzero(&newtio, sizeof(newtio));
        newtio.c_cflag = BAUDRATE |  CS8 | CLOCAL | CREAD;
        newtio.c_iflag = IGNPAR;
        newtio.c_oflag = 0;

	/* set input mode (non-canonical, no echo,...) */
        newtio.c_lflag = 0;
         
        newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
        newtio.c_cc[VMIN]     = 0;   /* blocking read until 5 chars received */
        
        tcflush(fd, TCIFLUSH);
        tcsetattr(fd,TCSANOW,&newtio);
        


}

int GetPacket(char* outputArray,int maxBytes)
{
 int res;
 static int bufpointer = 0;
 static char buf[255];
 char inChar;

 assert(maxBytes < 255);

 res = 1;
  while (res ==1)
  {
    res = read(fd,&inChar,1);   /* try to read a char... */
   if (res ==1)
   {
	buf[bufpointer] = inChar;
	if (buf[bufpointer] == '\n')
	{
	 buf[bufpointer+1] = 0; // so we can strncpy
	 bufpointer=0;

	 // Copy bufpointer to outputArray and return the
	 // length of the buffer.
	 strncpy(outputArray,buf,maxBytes);
	 return(strlen(buf));
	  
	}
	// check to see if our input is too long...
	if (bufpointer > maxBytes)
	{
	  bufpointer = -1;
	}
	bufpointer++;
   } // end if res == 1
  } // end while res == 1

  return(0);
}

void CloseSerialPort()
{
      tcsetattr(fd,TCSANOW,&oldtio); // restore old settings...
      close(fd);
}

      main()
      {
	char buffer[10];
        InitSerialPort(); 
        

        while (1) {       /* loop for input */
           if (GetPacket(buffer,10) != 0)
	   {
		   printf("%s",buffer);
	   }
	
        } // end while...

	CloseSerialPort();
      }

